<html xmlns:th="http://www.thymeleaf.org">

<!-- 

Arquivo que herda do base.html pára manter a aparência do sistema e que tem presente também o plot
de cada um dos gráficos que aparecerão. Além dos scripts para que se preencha os gráficos dinâmicamente
de acordo com o que o servidor spring for terminando de processar.

 -->

<head th:insert="~{base :: head}">
<title>Simulador Estrela - Index</title>
</head>
<body>
	<div th:replace="~{base :: header}"></div>

	<div class="container-fluid" th:fragment="header">
		<div class="row" style="margin-top: 20px;">
			<h3 class="col-12 offset-lg-2 col-lg-8 center">Gráficos Fila 1</h3>
		</div>
		<div class="row"></div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px">
				<canvas id="t1" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px;">
				<canvas id="w1" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px;">
				<canvas id="x1" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px;">
				<canvas id="nq1" width="100%" height="23px"></canvas>
			</div>
		</div>


		<div class="row" style="margin-top: 20px;">
			<h3 class="col-12 offset-lg-2 col-lg-8 center">Gráficos Fila 2</h3>
		</div>
		<div class="row"></div>


		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px">
				<canvas id="t2" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px">
				<canvas id="w2" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px">
				<canvas id="nq2" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px">
				<canvas id="edelta" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8" style="margin-top: 20px">
				<canvas id="vdelta" width="100%" height="23px"></canvas>
			</div>
		</div>
		<div class="row">
			<div class="col-12 offset-lg-2 col-lg-8">
				<table class="table">
					<thead>
						<tr>
							<th scope="col">Metrica</th>
							<th scope="col">Min</th>
							<th scope="col">Mediana</th>
							<th scope="col">Max</th>
							<th scope="col">Precisão</th>

						</tr>
					</thead>
					<tbody>
						<tr>
							<th scope="row">E[T1]</th>
							<td id="mt1min"></td>
							<td id="mt1"></td>
							<td id="mt1max"></td>
							<td id="mt1p"></td>

						</tr>
						<tr>
							<th scope="row">E[W1]</th>
							<td id="mw1min"></td>
							<td id="mw1"></td>
							<td id="mw1max"></td>
							<td id="mw1p"></td>

						</tr>
						<tr>
							<th scope="row">E[X1]</th>
							<td id="mx1min"></td>
							<td id="mx1"></td>
							<td id="mx1max"></td>
							<td id="mx1p"></td>


						</tr>
						<tr>
							<th scope="row">E[Nq1]</th>
							<td id="mn_q1min"></td>
							<td id="mn_q1"></td>
							<td id="mn_q1max"></td>
							<td id="mn_q1p"></td>

						</tr>
						<tr>
							<th scope="row">E[T2]</th>
							<td id="mt2min"></td>
							<td id="mt2"></td>
							<td id="mt2max"></td>
							<td id="mt2p"></td>
						</tr>
						<tr>
							<th scope="row">E[W2]</th>
							<td id="mw2min"></td>
							<td id="mw2"></td>
							<td id="mw2max"></td>
							<td id="mw2p"></td>
						</tr>
						<tr>
							<th scope="row">E[Nq2]</th>
							<td id="mn_q2min"></td>
							<td id="mn_q2"></td>
							<td id="mn_q2max"></td>
							<td id="mn_q2p"></td>

						</tr>
						<tr>
							<th scope="row">E[Delta]</th>
							<td id="mdeltamin"></td>
							<td id="mdelta"></td>
							<td id="mdeltamax"></td>
							<td id="mdeltap"></td>
						</tr>
						<tr>
							<th scope="row">V(Delta)</th>
							<td id="vdelta_tabela_min"></td>
							<td id="vdelta_tabela"></td>
							<td id="vdelta_tabela_max"></td>
							<td id="vdelta_tabela_p"></td>
						</tr>
					</tbody>
				</table>
			</div>
		</div>
	</div>
	<div th:replace="~{base :: footer}"></div>

	<script th:src="@{/js/chart.min.js}" crossorigin="anonymous"></script>

	<script>
		var ct1x = document.getElementById("t1").getContext('2d');
		var t1 = new Chart(ct1x, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Tempo Total Médio Fila 1",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				},
				scales : {
					yAxes : [ {
						ticks : {
							beginAtZero : true
						}
					} ]
				}
			}
		});

		var cw1x = document.getElementById("w1").getContext('2d');
		var w1 = new Chart(cw1x, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Tempo de Espera Médio Fila 1",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				}
			}
		});

		var cx1x = document.getElementById("x1").getContext('2d');
		var x1 = new Chart(cx1x, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Tempo de Processamento Médio Fila 1",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				}
			}
		});

		var cnq1x = document.getElementById("nq1").getContext('2d');
		var nq1 = new Chart(cnq1x, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Tamanho Médio Fila 1",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				}
			}
		});

		var ct2x = document.getElementById("t2").getContext('2d');
		var t2 = new Chart(ct2x, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Tempo Médio Fila 2",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				}
			}
		});

		var cw2x = document.getElementById("w2").getContext('2d');
		var w2 = new Chart(cw2x, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Tempo Médio de Espera Fila 2",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				}
			}
		});

		var cnq2x = document.getElementById("nq2").getContext('2d');
		var nq2 = new Chart(cnq2x, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Tamanho Médio Fila 2",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				}
			}
		});

		var cedeltax = document.getElementById("edelta").getContext('2d');
		var edelta = new Chart(cedeltax, {
			type : 'scatter',
			label : "teste",
			data : {
				datasets : [ {
					label : "Média Delta",
					data : [],
					backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
							'rgba(54, 162, 235, 0.2)',
							'rgba(255, 206, 86, 0.2)',
							'rgba(75, 192, 192, 0.2)',
							'rgba(153, 102, 255, 0.2)',
							'rgba(255, 159, 64, 0.2)' ],
					borderColor : [ 'rgba(255,99,132,1)',
							'rgba(54, 162, 235, 1)', 'rgba(255, 206, 86, 1)',
							'rgba(75, 192, 192, 1)', 'rgba(153, 102, 255, 1)',
							'rgba(255, 159, 64, 1)' ],
					borderWidth : 1
				} ]
			},
			options : {
				showLines : true,
				elements : {
					line : {
						tension : 0, // disables bezier curves
					}
				}
			}
		});

		var cvdeltax = document.getElementById("vdelta").getContext('2d');
		var vdelta = new Chart(
				cvdeltax,
				{
					type : 'scatter',
					label : "teste",
					data : {
						datasets : [ {
							label : "Variância Delta (como esse valor é muito pequeno pode não aparecer no gráfico)",
							data : [],
							backgroundColor : [ 'rgba(255, 99, 132, 0.2)',
									'rgba(54, 162, 235, 0.2)',
									'rgba(255, 206, 86, 0.2)',
									'rgba(75, 192, 192, 0.2)',
									'rgba(153, 102, 255, 0.2)',
									'rgba(255, 159, 64, 0.2)' ],
							borderColor : [ 'rgba(255,99,132,1)',
									'rgba(54, 162, 235, 1)',
									'rgba(255, 206, 86, 1)',
									'rgba(75, 192, 192, 1)',
									'rgba(153, 102, 255, 1)',
									'rgba(255, 159, 64, 1)' ],
							borderWidth : 1
						} ]
					},
					options : {
						showLines : true,
						elements : {
							line : {
								tension : 0, // disables bezier curves
							}
						}
					}
				});
	</script>

	<script th:src="@{/js/jquery.js}">
		
	</script>

	<script>
		var simulacao_chegou_ao_fim = false;
		var dados;
		var initial = 0;
		var tem_nulo = function(fila1, fila2) {

			if (fila1.esperanca_tempo_total_rodada == null
					|| fila1.esperanca_espera_rodada == null
					|| fila1.esperanca_servico_rodada == null
					|| fila1.esperanca_N_q_rodada == null
					|| fila2.esperanca_tempo_total_rodada == null
					|| fila2.esperanca_espera_rodada == null
					|| fila2.esperanca_N_q_rodada == null
					|| fila2.esperanca_delta_rodada == null
					|| fila2.variancia_delta_rodada == null)
				return true
			return false
		}
		var atualizaDados = function() {
			$
					.get(
							"[[@{/getDados}]]" + "/?ultimoIndiceRecebido="
									+ initial,
							function(data, status) {
								if (!simulacao_chegou_ao_fim) {
									if (status == 'success' && data != "") {
										dados = JSON.parse(data);

										fila1 = dados[0];
										fila2 = dados[1];
										simulacao_chegou_ao_fim = dados[0].simulacao_chegou_ao_fim;
										if (!tem_nulo(fila1, fila2)) {
											console.log("Teste")
											for (var i = 0; i < fila2.esperanca_tempo_total_rodada.length; i++) {
												t1.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila1.esperanca_tempo_total_rodada[i]
														});
												t1.update();

												w1.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila1.esperanca_espera_rodada[i]
														});
												w1.update();

												x1.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila1.esperanca_servico_rodada[i]
														});
												x1.update();

												nq1.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila1.esperanca_N_q_rodada[i]
														});
												nq1.update();

												t2.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila2.esperanca_tempo_total_rodada[i]
														});
												t2.update();

												w2.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila2.esperanca_espera_rodada[i]
														});
												w2.update();

												nq2.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila2.esperanca_N_q_rodada[i]
														});
												nq2.update();

												edelta.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila2.esperanca_delta_rodada[i]
														});
												edelta.update();

												vdelta.data.datasets[0].data
														.push({
															x : initial + i + 1,
															y : fila2.variancia_delta_rodada[i]
														});
												vdelta.update();
											}
											initial += fila2.variancia_delta_rodada.length;
										}
									}
									setTimeout(atualizaDados, 5);
								} else {
									atualizaTabela();
								}
							});
		}
		var dat;
		var atualizaTabela = function() {
			$.get("[[@{/atualizaTabela}]]", function(data, status) {
				if (status == 'success' && data != "") {
					dat = JSON.parse(data);
					$("#mt1min").text(dat.mt1min);
					$("#mt1").text(dat.mt1);
					$("#mt1max").text(dat.mt1max);
					$("#mt1p").text(dat.mt1p);

					$("#mw1min").text(dat.mw1min);
					$("#mw1").text(dat.mw1);
					$("#mw1max").text(dat.mw1max);
					$("#mw1p").text(dat.mw1p);

					$("#mx1min").text(dat.mx1min);
					$("#mx1").text(dat.mx1);
					$("#mx1max").text(dat.mx1max);
					$("#mx1p").text(dat.mx1p);

					$("#mn_q1min").text(dat.mn_q1min);
					$("#mn_q1").text(dat.mn_q1);
					$("#mn_q1max").text(dat.mn_q1max);
					$("#mn_q1p").text(dat.mn_q1p);


					$("#mt2min").text(dat.mt2min);
					$("#mt2").text(dat.mt2);
					$("#mt2max").text(dat.mt2max);
					$("#mt2p").text(dat.mt2p);

					$("#mw2min").text(dat.mw2min);
					$("#mw2").text(dat.mw2);
					$("#mw2max").text(dat.mw2max);
					$("#mw2p").text(dat.mw2p);

					$("#mn_q2min").text(dat.mn_q2min);
					$("#mn_q2").text(dat.mn_q2);
					$("#mn_q2max").text(dat.mn_q2max);
					$("#mn_q2p").text(dat.mn_q2p);


					$("#mdeltamin").text(dat.mdeltamin);
					$("#mdelta").text(dat.mdelta);
					$("#mdeltamax").text(dat.mdeltamax);
					$("#mdeltap").text(dat.mdeltap);

					$("#vdelta_tabela_min").text(dat.vdelta_tabela_min);
					$("#vdelta_tabela").text(dat.vdelta_tabela);
					$("#vdelta_tabela_max").text(dat.vdelta_tabela_max);
					$("#vdelta_tabela_p").text(dat.vdelta_tabela_p);
				}
			});
		}
		$(document).ready(atualizaDados);
	</script>



</body>
</html>